#!/bin/sh

# corpus.?.txt ʲ 2ե
#
# corpus.1g.txt:
# 2ʸʾʸ 1ʸᤴȤʬ䤷
#
# |餷||| ||ī|褿|
#     
# |餷| ||
# || |ī|
# || |褿|
# 
# corpus.2g.txt:
# 3ʸʾʸ 2ʸᤴȤʬ䤷
#
# |餷||| ||ī|褿|
#     
# |餷|| ||ī|
# ||| |ī|褿|
# 

LANG=ja_JP.eucJP; export LANG



for fy in "$@"
do
   awk '/^\|/{
      m1=split($1,yomi,"|")
      m2=split($2,kekka,"|")
#      m3=split($3,code,"|")
#      if ( m1 != m2 || m2 != m3){
      if ( m1 != m2 ){
         print FILENAME": "FNR": Number of fields is unmatch" > "/dev/stderr"
      } else if ( m1 > 3 ){
         for (i=2; i <= (m1-1); i++){
#            print "|"yomi[i]"| |"kekka[i]"| |"code[i]"|"
            print "|"yomi[i]"| |"kekka[i]"|"
         }
      }
   }' "${fy}"
done |\
sort | uniq > corpus.1g.txt


for fz in "$@"
do
   awk '/^\|/{
      n1=split($1,yomi,"|")
      n2=split($2,kekka,"|")
#      n3=split($3,code,"|")
#      if (n1 != n2 || n2 != n3){
      if (n1 != n2 ){
         print FILENAME": "FNR": number of fields is unmatch" > "/dev/stderr"
      } else if (n1 > 4){
         for(i=2; i <= (n1-2); i++){
#            print "|"yomi[i]"|"yomi[i+1]"| |"kekka[i]"|"kekka[i+1]"| |"code[i]"|"code[i+1]"|"
            print "|"yomi[i]"|"yomi[i+1]"| |"kekka[i]"|"kekka[i+1]"|"
         }
      }
   }' "${fz}"
done |\
sort | uniq > corpus.2g.txt



